LFGTimer = LibStub("AceAddon-3.0"):NewAddon("LFGTimer", "AceEvent-3.0");
local addon = LFGTimer; -- upvalue the addon table
local L = LibStub("AceLocale-3.0"):GetLocale("LFGTimer", true);

local db;

function addon:OnInitialize()
	self:InitConfig(); -- setup config system
	db = self.db.profile; -- make sure this file has a valid db handle
	self:SetupFloatingFrame();
	self:RegisterEvent("LFG_UPDATE", "UpdateFrameShown");
	self:RegisterEvent("LFG_PROPOSAL_UPDATE", "UpdateFrameShown");
	self:RegisterEvent("LFG_PROPOSAL_SHOW", "UpdateFrameShown");
	self:RegisterEvent("LFG_PROPOSAL_FAILED", "UpdateFrameShown");
	self:RegisterEvent("LFG_PROPOSAL_SUCCEEDED", "UpdateFrameShown");
	self:RegisterEvent("LFG_ROLE_CHECK_SHOW", "UpdateFrameShown");
	self:RegisterEvent("LFG_ROLE_CHECK_HIDE", "UpdateFrameShown");
	self:RegisterEvent("LFG_BOOT_PROPOSAL_UPDATE", "UpdateFrameShown");
	self:RegisterEvent("VOTE_KICK_REASON_NEEDED", "UpdateFrameShown");
	self:RegisterEvent("LFG_ROLE_UPDATE", "UpdateFrameShown");
	self:RegisterEvent("LFG_UPDATE_RANDOM_INFO", "UpdateFrameShown");
	self:RegisterEvent("LFG_OPEN_FROM_GOSSIP", "UpdateFrameShown");
	self:RegisterEvent("GOSSIP_CLOSED", "UpdateFrameShown");
--	self:RegisterEvent("LFG_QUEUE_STATUS_UPDATE", "WTFIsThis");
end

function addon:WTFIsThis(...)
	for i = 1, select("#", ...) do
		print(tostring(select(i, ...)));
	end
end

function addon:UpdateMainDB(database)
	db = database;
end

addon.StringHooks = setmetatable({}, {
	__index = function(t, k)
		local f = addon:CreateStringHook(k);
		if f then
			rawset(t, k, f);
		end
		return f;
	end,
});

local function errH(...) -- respects hooking of geterrorhandler
	return geterrorhandler(...);
end

function addon:CreateStringHook(func)
	assert(type(func) == "string");
	local code = [[
		local xpcall, eh, tbl = ...;
		local args;
		local function call()
			return tbl:FUNC_NAME(unpack(args));
		end
		local function Call(...)
			args = {...};
			xpcall(call, eh);
			args[1] = true;
			args[1] = nil;
			args = nil; -- clean up the table
		end
		return Call;
	]];
	code = string.gsub(code, "FUNC_NAME", func);
	code = assert(loadstring(code, "safe call stringHook(" .. func .. ")"));
	return code(xpcall, errH, addon);
end
